/**
 * UDP Simple Server ist ein kleines Netzwerktool auf Basis des TCP Protokolls
 * welches nur die Verbindung eines Client entgegennehmen kann
 * Quelle http://www.wut.de
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import java.io.*;

public class TCP_Simple_Server extends JFrame implements ActionListener,Runnable{
	private static final long serialVersionUID = 1L;
	//Grafikelemente
	private Container co;
	private JLabel lb[] = new JLabel[3];
	private JButton bt[] = new JButton[3];
	private JTextField tf[] = new JTextField[3];
	private JCheckBox cb_newline = new JCheckBox("add CR LF");
	private JTextArea ta = new JTextArea(4, 20);
	private JScrollPane scrollPane = new JScrollPane(ta);
	//Verbindungselemente
	private  Socket socket;
	private ServerSocket serversocket;
	private PrintWriter out;
	private InputStream in;
	private boolean started = false;
	
	
	public TCP_Simple_Server(String name){
		super(name);
		this.setLocation(300,300);
		this.setSize(390,286);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	
		//Fenster-------
		co = getContentPane();
		co.setLayout(null);
		//Erzeugung der Buttons
		String[] s2 ={"Listen","Send","Disconnect"};
		for(int i=0;i<=2;i++){
			bt[i]= new JButton(s2[i]);
			bt[i].addActionListener(this);
			co.add(bt[i]);
		}
		bt[0].setBounds(270,25,100,25); // X-Pos,Y-Pos,Breite,Hhe
		bt[1].setBounds(270,75,100,25);
		bt[2].setBounds(270,190,100,25);
		bt[1].setEnabled(false);
		bt[2].setEnabled(false);
			
		//Erzeugung der Labels
		String[] s ={"Local Port","Send Data","Receive Data"};
		for(int i=0;i<=2;i++){
			lb[i] = new JLabel(s[i]);
			co.add(lb[i]);
		}
		lb[0].setBounds(150,3,100,25);
		lb[1].setBounds(5,52,100,25);
		lb[2].setBounds(5,100,100,25);
		
		
		
		//Erzeugung der Textfelder
		for(int i=0;i<=2;i++){
			tf[i]=new JTextField();
			co.add(tf[i]);
		}
		tf[1].setBounds(150,25,115,20);
		tf[2].setBounds(5,75,150,20);
		
		tf[0].setBounds(5,225,365,25);
		tf[0].setEditable(false);
		tf[2].setEditable(false);
		
		tf[0].setText("Statusbar");
			
		//Erzeugung der Checkbox
		co.add(cb_newline);
		cb_newline.setBounds(175,75,90,20);
		cb_newline.setEnabled(false);
		
		//Erzeung der Textarea 	
		scrollPane.setBounds(5,125,260,90);
		ta.setEditable(false);
		co.add(scrollPane);

		//Fenster sichtbar machen wenn alles geladen ist
		this.setVisible(true);
	}
	public void actionPerformed(ActionEvent e){
		if(e.getActionCommand()=="Listen"){
			this.listen();	
		}else if(e.getActionCommand()=="Send"){
			this.send();
		}else if(e.getActionCommand()=="Disconnect"){
			this.disconnect();
		}
	}
	public void listen(){
		if(!tf[1].getText().isEmpty()){
			int port=Integer.parseInt( tf[1].getText());
			try{
				if(started == false){
					serversocket = new ServerSocket(port);
					started = true;
				}
				new Thread(this).start();
				bt[0].setEnabled(false);
				bt[1].setEnabled(false);
				bt[2].setEnabled(true);
				tf[1].setEditable(false);
				tf[2].setEditable(false);
				cb_newline.setEnabled(false);
				tf[0].setText("Waiting for Client");
			}catch(IOException e){
				tf[0].setText("error: "+e.getMessage());
			}
		}
	}
	public void send(){
		if(!tf[2].getText().isEmpty()){
			String message = tf[2].getText();
			if(cb_newline.isSelected()){
				message += "\n";
			}
			out.print(message);
	        out.flush();
		}
	}
	public void disconnect(){		
		started=false;
		try{
			if(socket!=null && socket.isBound()){
				socket.close();
			}
			serversocket.close();
			bt[0].setEnabled(true);
			bt[1].setEnabled(false);
			bt[2].setEnabled(false);
			tf[1].setEditable(true);
			tf[2].setEditable(false);
			cb_newline.setEnabled(false);
			tf[0].setText("Serversocket closed");
		}catch(Exception e){
			tf[0].setText("error: "+e.getMessage());
			
		}
		
	}
	public void run()
	{
		try{
			socket = serversocket.accept();
			OutputStreamWriter ow;
			ow =  new OutputStreamWriter(socket.getOutputStream());
			out = new PrintWriter(ow);
			in = socket.getInputStream();
			bt[1].setEnabled(true);
			tf[2].setEditable(true);
			cb_newline.setEnabled(true);
			tf[0].setText("Connected");
			int sign;//ASCII
			   
			while ((sign = in.read()) != -1) { 
			   if(sign != 00){					   
				   ta.append(String.valueOf((char)sign));
				  }
			   } 
		}catch(IOException e){
			tf[0].setText("error: "+e.getMessage());
			
		}
		
	   if(started){	
		   this.listen();
	   }
	}
	public static void main(String[] args) {
			new TCP_Simple_Server("TCP Simple Server");
	}
}